Imports FarPoint.Win
Imports System
Imports System.Windows.Forms

Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        FpSpread1.Sheets(0).ColumnCount = 1
        FpSpread1.Sheets(0).RowCount = 1

        FpSpread1.Sheets(0).Cells(0, 0).CellType = New SimpleDateTimeCellType

    End Sub

End Class

Public Class SimpleDateTimeCellType
    Inherits FarPoint.Win.Spread.CellType.DateTimeCellType

    Private mSubEditor As SimpleDateTimeCellSubEditor = Nothing

    Public Overrides Function GetEditorControl(ByVal appearance As FarPoint.Win.Spread.Appearance, ByVal zoomFactor As Single) As System.Windows.Forms.Control
        If mSubEditor Is Nothing Then
            mSubEditor = New SimpleDateTimeCellSubEditor
        End If

        MyBase.SubEditor = CType(mSubEditor, FarPoint.Win.Spread.CellType.ISubEditor)
        Return MyBase.GetEditorControl(appearance, zoomFactor)
    End Function
End Class

Public Class SimpleDateTimeCellSubEditor
    Inherits Form
    Implements FarPoint.Win.Spread.CellType.ISubEditor


    Private mFormatter As FarPoint.Win.SuperEdit.MaskFormatter = New FarPoint.Win.SuperEdit.MaskFormatter
    Public Event CloseUp(ByVal sender As Object, ByVal e As System.EventArgs) Implements FarPoint.Win.Spread.CellType.ISubEditor.CloseUp
    Private mEditorValue As Object = Nothing
    Private mDateTimeFormat As FarPoint.Win.Spread.CellType.DateTimeFormat = Spread.CellType.DateTimeFormat.ShortDate

    Public Property EditorValue() As Object
        Get
            Return mEditorValue
        End Get
        Set(ByVal value As Object)
            mEditorValue = value
        End Set
    End Property
    Public Function GetLocation(ByVal rect As System.Drawing.Rectangle) As System.Drawing.Point Implements FarPoint.Win.Spread.CellType.ISubEditor.GetLocation
        Return rect.Location
    End Function

    Public Function GetPreferredSize() As System.Drawing.Size Implements FarPoint.Win.Spread.CellType.ISubEditor.GetPreferredSize
        Return Me.GetPreferredSize
    End Function

    Public Function GetSubEditorControl() As System.Windows.Forms.Control Implements FarPoint.Win.Spread.CellType.ISubEditor.GetSubEditorControl
        mFormatter.MaskType = FarPoint.Win.SuperEdit.MaskType.Date
        Select Case mDateTimeFormat
            Case Else
                Dim dateFormat As String = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.ShortDatePattern
                Dim regEx As New System.Text.RegularExpressions.Regex("\b(dd)\b", System.Text.RegularExpressions.RegexOptions.IgnoreCase)

                If Not regEx.Match(dateFormat, 0).Success Then
                    dateFormat = regEx.Replace(dateFormat, "d", "dd", System.Text.RegularExpressions.RegexOptions.IgnoreCase)
                End If
                regEx = New System.Text.RegularExpressions.Regex("\b(MM)\b", System.Text.RegularExpressions.RegexOptions.IgnoreCase)

                If Not regEx.Match(dateFormat, 0).Success Then
                    dateFormat = regEx.Replace(dateFormat, "m", "MM", System.Text.RegularExpressions.RegexOptions.IgnoreCase)
                End If
                mFormatter.FormatString = dateFormat
        End Select

        'How do I put a formatter to this subEditorControl?

        Return Me
    End Function

    Public Function GetValue() As Object Implements FarPoint.Win.Spread.CellType.ISubEditor.GetValue
        Return EditorValue
    End Function

    Public Sub SetValue(ByVal value As Object) Implements FarPoint.Win.Spread.CellType.ISubEditor.SetValue
        Me.EditorValue = value
    End Sub

    Public Event ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Implements FarPoint.Win.Spread.CellType.ISubEditor.ValueChanged
End Class

